<%@ Page Language="C#" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.OleDb" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<script runat="server">
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack) {
            CreateTreeView();
        }
    }

    /// <summary>
    ///  TreeView
    /// ˷ȡһԼĿݵ DataTableݹѯ DataTable ӽڵ
    /// </summary>
    private void CreateTreeView()
    {
        //
        const int VirtualRootId = 0; // ĸڵ ID  ParentID=0 Ľڵʾʵʸڵ
        const string SQL_SELECT = "SELECT NodeId, NodeName,ParentId FROM TreeView ORDER BY NodeId ASC";
        
        //
        string connStr = "Provider=Microsoft.Jet.OleDb.4.0;data source=" + Server.MapPath("TreeViewDemo.mdb"); ;        
        //
        OleDbDataAdapter da = new OleDbDataAdapter(SQL_SELECT, connStr);
        DataTable dt = new DataTable();
        //
        da.Fill(dt);
        //
        CreateTreeViewRecursive(treeMenu.Nodes, dt, 0);
    }

    /// <summary>
    /// ݹѯݣ TreeNode ڵ
    /// </summary>
    /// <param name="nodes"></param>
    /// <param name="dataSource"></param>
    /// <param name="parentId"></param>
    private void CreateTreeViewRecursive(TreeNodeCollection nodes, DataTable dataSource, int parentId)
    {
        //
        string fliter = String.Format("ParentId={0}", parentId);
        // ѯӽڵ
        DataRow[] drArr = dataSource.Select(fliter);
        
        TreeNode node;        
        foreach(DataRow dr in drArr) {                        
            //
            node = new TreeNode();
            nodes.Add(node);
            node.Text = (string)dr["NodeName"];            
            // 
            // ...     
                       
            // ݹ鴴ӽڵ
            CreateTreeViewRecursive(node.ChildNodes, dataSource, (int)dr["NodeId"]);
            
            // ƳУ
            dataSource.Rows.Remove(dr);
        }
    }

</script>

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>CreateTreeViewResursiveFromDb</title>
</head>
<body>
    <form id="form1" runat="server">
    <div>
        <asp:TreeView ID="treeMenu" runat="server"  ExpandDepth="1">
        </asp:TreeView>
    </div>
    </form>
</body>
</html>
